!  ** demo90.f90 **

MODULE M
  TYPE MYTYPE
    CHARACTER*10    NAME
    INTEGER(KIND=4) SCORES(2,2)
  END TYPE

  REAL, PRIVATE :: LOC(10)  
  INTEGER AVE 
  CHARACTER*2 GRADE(6)
  PARAMETER (GRADE = (/'A', 'B', 'C', 'D', 'E', 'F'/) )

CONTAINS
! ------ Internal subprograms --------
  SUBROUTINE M_INNER(TYPE1, TYPE2)
    TYPE (MYTYPE), INTENT(INOUT) :: TYPE1
    TYPE (MYTYPE), INTENT(IN)    :: TYPE2
    TYPE1%NAME = 'ALIAS: ' // TYPE2%NAME  
  END SUBROUTINE M_INNER

END MODULE


      SUBROUTINE OUTER(TYPE1, TYPE2, OPDUM)
!     ----- Declaration ----- 
        USE M, ONLY : MYTYPE
        TYPE (MYTYPE), INTENT(INOUT) :: TYPE1, TYPE2 
        INTEGER, OPTIONAL :: OPDUM
!     ----- Double TYPE2's scores.
        if ( PRESENT(OPDUM) ) THEN
           TYPE1%SCORES(1, 1) = TYPE2%SCORES(1) * OPDUM
        ELSE
           TYPE1%SCORES(1, 1) = TYPE2%SCORES(1, 1) * 2  
        ENDIF
      END SUBROUTINE

PROGRAM MAIN
! --------- Main program --------

  USE M, TYPE_S => MYTYPE, &
         MYLOC  => LOC     !private module entities cannot be accessed
  CHARACTER(LEN = 10) STR
  TYPE (TYPE_S) STUDENT1, STUDENT2

  CALL M_INNER(STUDENT1, STUDENT2) 
  CALL OUTER(STUDENT1, STUDENT2) 
  STR = GRADE(3) 
  AVE = MAIN_INNER( STUDENT1%SCORES )

CONTAINS
! Internal subprograms are in another file
  INCLUDE 'demo90.inc'
END
