! File: common.f90

MODULE MOD1
TYPE PERSON
  CHARACTER(len = 30) :: NAME
  INTEGER :: SSN
END TYPE

TYPE EMPLOYEE
  TYPE (PERSON) :: INFO
  INTEGER :: VACDAYS
  INTEGER :: PERFORMANCE
END TYPE

INTEGER, parameter :: NUMOFWORKERS = 100
TYPE(EMPLOYEE) :: WORKERS(NUMOFWORKERS) 

INTEGER, parameter :: GOOD = 1
INTEGER, parameter :: VERYFOOD = 2 
INTEGER, parameter :: EXCELLENT = 3

CONTAINS
  SUBROUTINE ADDVAC(WORKER, DAYS)
    TYPE(EMPLOYEE), INTENT(IN) :: WORKER    !FYI: unused
    INTEGER, INTENT(IN) :: DAYS 
    IF (DAYS <= 1) DAYS = 1   !ERR: INTENT(in) arg redefined
    WORKERS%VACDAYS = WORKERS%VACDAYS + DAYS
  END SUBROUTINE ADDVAC

  FUNCTION WORKTOOHARD(WORKER)
    LOGICAL WORKTOOHARD
    TYPE(EMPLOYEE), INTENT(IN) :: WORKER
    INTEGER :: GRADE
    IF (WORKER%PERFORMANCE > GOOD) THEN 
      WORKTOOHARD = .TRUE.
    ELSE
      WORKTOOHARD = .FALSE.
    ENDIF

    IF (NUMDAYS > 20) CALL REMINDVAC(NUMDAYS)
  END FUNCTION WORKTOOHARD

END MODULE

SUBROUTINE REMINDVAC(NUMDAYS)
INTEGER, INTENT(IN), OPTIONAL :: NUMDAYS

IF (PRESENT(NUMDAYS)) THEN
   WRITE(*, *) 'You have too many vacation days. (', NUMDAYS, ')'
ELSE  
   WRITE(*, *) 'You have too many vacation days.'
ENDIF
RETURN
END SUBROUTINE
